var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { EditorView } from "codemirror";
import { imagePreview } from "../state/image";
import { image as classes } from "../classes";
import {
  Decoration,
  ViewPlugin
} from "@codemirror/view";
import {
  iterateTreeInVisibleRanges,
  isCursorInRange,
  invisibleDecoration
} from "../util";
function hideNodes(view) {
  const widgets = new Array();
  iterateTreeInVisibleRanges(view, {
    enter(node) {
      if (node.name === "Image" && !isCursorInRange(view, [node.from, node.to])) {
        widgets.push(invisibleDecoration.range(node.from, node.to));
      }
    }
  });
  return Decoration.set(widgets, true);
}
const hideImageNodePlugin = ViewPlugin.fromClass(class {
  constructor(view) {
    __publicField(this, "decorations");
    this.decorations = hideNodes(view);
  }
  update(update) {
    if (update.docChanged || update.selectionSet)
      this.decorations = hideNodes(update.view);
  }
}, { decorations: (v) => v.decorations });
const image = () => [
  imagePreview,
  hideImageNodePlugin,
  baseTheme
];
const baseTheme = EditorView.baseTheme({
  ["." + classes.widget]: {
    display: "block",
    objectFit: "contain",
    maxWidth: "100%",
    paddingLeft: "4px",
    maxHeight: "100%",
    userSelect: "none"
  }
});
export {
  image
};
//# sourceMappingURL=image.js.map
