import { StateField } from '@codemirror/state';
import { DecorationSet } from '@codemirror/view';
/**
 * Representation of the data held by the image URL state field.
 */
export interface ImageInfo {
    /** The source of the image. */
    src: string;
    /** The starting position of the image element in the document. */
    from: number;
    /** The end position of the image element in the document. */
    to: number;
    /** The alt text of the image. */
    alt: string;
}
/**
 * The current state of the image preview widget.
 * Used to indicate to render a placeholder or the actual image.
 */
export declare enum WidgetState {
    INITIAL = 0,
    LOADED = 1
}
/**
 * The state effect to dispatch when a image loads, regardless of the result.
 */
export declare const imageLoadedEffect: import("@codemirror/state").StateEffectType<ImageInfo>;
/** State field to store image preview decorations. */
export declare const imagePreview: StateField<DecorationSet>;
