var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { foldedRanges, syntaxTree } from "@codemirror/language";
import { Decoration } from "@codemirror/view";
function checkRangeOverlap(range1, range2) {
  return range1[0] <= range2[1] && range2[0] <= range1[1];
}
function checkRangeSubset(parent, child) {
  return child[0] >= parent[0] && child[1] <= parent[1];
}
function isCursorInRange(view, range) {
  return view.state.selection.ranges.some((selection) => checkRangeOverlap(range, [selection.from, selection.to]));
}
function iterateTreeInVisibleRanges(view, iterateFns) {
  for (const { from, to } of view.visibleRanges) {
    syntaxTree(view.state).iterate(__spreadProps(__spreadValues({}, iterateFns), { from, to }));
  }
}
const invisibleDecoration = Decoration.replace({});
function editorLines(view, from, to) {
  let lines = view.viewportLineBlocks.filter((block) => checkRangeOverlap([block.from, block.to], [from, to]));
  const folded = foldedRanges(view.state).iter();
  while (folded.value) {
    lines = lines.filter((line) => !checkRangeOverlap([folded.from, folded.to], [line.from, line.to]));
    folded.next();
  }
  return lines;
}
class Slugger {
  constructor() {
    __publicField(this, "occurences", {});
  }
  slug(text) {
    let slug = text.toLowerCase().replace(/\s+/g, "-").replace(/[^\w-]+/g, "");
    if (slug in this.occurences) {
      this.occurences[slug]++;
      slug += "-" + this.occurences[slug];
    } else {
      this.occurences[slug] = 1;
    }
    return slug;
  }
}
export {
  Slugger,
  checkRangeOverlap,
  checkRangeSubset,
  editorLines,
  invisibleDecoration,
  isCursorInRange,
  iterateTreeInVisibleRanges
};
//# sourceMappingURL=util.js.map
